;***************************************************************************
; Hodiny V2.0    (c) ASIX s.r.o. 1997
; Peklad oven na pekladai:
;   MPASM 01.21 Released (c) 1993-95 Byte Craft Limited,
; monost naprogramovn souboru vzniklho pekladem na zazen:
;   PVKpro V1.0  (c) ASIX s.r.o. 1997.
;***************************************************************************
        list    F=inhx8m, p=16c84, r=hex        ; pro peklada
        __config        3ff1h                   ; pojistky
; Frekvence vnjho osciltoru je 3.2768MHz => instrukn cyklus = 1.22s
; kdy to vynsobme 256 (tmr0) a 16 (peddli), dostaneme pesn 5ms.
; Pojistky: Osc: XT, PuT: On, WDT: Off, CP: Off.
;***************************************************************************
; Zapojen pin:
;   RA0 buzen anody tvrt slice zleva (DISP0)                  (out)
;   RA1 buzen anody tet  slice zleva (DISP1)                  (out)
;   RA2 buzen anody druh  slice zleva (DISP2)                  (out)
;   RA3 buzen anody prvn  slice zleva (DISP3)                  (out)
;   RA4 buzen anod LED diod (D0 a D7)                            (out)
;   RB0 a RB7 jednotliv segmenty slic, pouv se v multiplexu (out)
;   RB0 tlatko TL0 - start / stop                                (in)
;   RB1 tlatko TL1 - pepnn zobrazovn                       (in)
;   RB2 tlatko TL2 - nastaven hodin                             (in)
;   RB3 tlatko TL3 - nastaven minut                             (in)
;***************************************************************************
; peddefinovan registry procesoru:
indf    equ     00h
tmr0    equ     01h
pcl     equ     02h
status  equ     03h
fsr     equ     04h
porta   equ     05h
portb   equ     06h
pclath  equ     0ah
intcon  equ     0bh
roption equ     01h     ; nesm se jmenovat pouze option, to je tak instrukce
trisa   equ     05h
trisb   equ     06h

; definice uivatelskch registr:
sec     equ     10h     ; registr na uloen vtein v BCD kdu
min     equ     11h     ; registr na uloen minut v BCD kdu
hod     equ     12h     ; registr na uloen hodin v BCD kdu
                        ; mus bt za sebou v tomto poad

citac   equ     13h     ; ta 1 vteiny
konec   equ     14h     ; registr pro uloen konen hodnoty pi aktualizaci
stav1   equ     15h     ; stav systmu
                        ; bit0: 0 tlatko nestisknuto (poten stav)
                        ;       1 tlatko uznno za stisknut a stle dreno
                        ; bit1: 0 hodiny b (poten stav)
                        ;       1 hodiny stoj
                        ; bit2: 0 zobrazujeme hodiny a minuty (poten stav)
                        ;       1 zobrazujeme minuty a vteiny
cit_m   equ     16h     ; ta multiplexu, t 0,1,2,3,0,1,2,3,0,1,...
digit   equ     17h     ; registr pro zobrazovanou slici
new     equ     18h     ; registr na uloen stavu tlatek - nov hodnoty
old     equ     19h     ; registr na uloen stavu tlatek - star hodnoty
cit_p   equ     1ah     ; ta prodlevy

; definice konstant:
w       equ     00h
f       equ     01h

; definice substituc:
#define carry   status, 0       ; pochopitelnj ne samotn C
#define dcarry  status, 1       ; pochopitelnj ne samotn DC
#define zero    status, 2       ; pochopitelnj ne samotn Z
#define push    stav1, 0        ; bit 0 registru stav1
#define stop    stav1, 1        ; bit 1 registru stav1
#define hm      stav1, 2        ; bit 2 registru stav1
#define dp      portb, 7        ; bit 7 portu B (desetinn teka)

; definice makroinstrukc:
bnk0    macro                   ; makroinstrukce na vbr banky 0
        bcf     status, 6
        bcf     status, 5
        endm
bnk1    macro                   ; makroinstrukce na vbr banky 1
        bcf     status, 6
        bsf     status, 5
        endm

        org     000h            ; program zan v pamti od adresy 000h
;***************************************************************************
        clrf    pclath          ; pro jistotu nulujeme horn bity programovho
                                ; tae ped vykonnm skok a rutin
        goto    init            ; skok na zatek programu
;***************************************************************************
; Rutina kduje BCD slice na kd pro sedmisegmentov displej. Vstup i vs-
; tup se dje pes registr w, vstup je slice BCD, vstupem je pak obsah
; registru w, kter posln na port B rozsvt pslunou slici. Segment
; svt, je-li pslun bit portu B v nule.
tab1    addwf   pcl, f          ; vbr slice
        retlw   b'11000000'     ; 0 - zobraz 0
        retlw   b'11111001'     ; 1 - zobraz 1
        retlw   b'10100100'     ; 2 - zobraz 2
        retlw   b'10110000'     ; 3 - zobraz 3
        retlw   b'10011001'     ; 4 - zobraz 4
        retlw   b'10010010'     ; 5 - zobraz 5
        retlw   b'10000010'     ; 6 - zobraz 6
        retlw   b'11111000'     ; 7 - zobraz 7
        retlw   b'10000000'     ; 8 - zobraz 8
        retlw   b'10010000'     ; 9 - zobraz 9
;***************************************************************************
; Rutina kduje podle cit_m jednu anodu, kter bude aktivn. Vstup i vstup
; je opt pes registr w, vstup se tentokrt posl na port A. Anoda je
; aktivovna, je-li pslun bit portu A v nule.
tab2    addwf   pcl, f          ; vbr anody
        retlw   b'11111110'     ; cit_m=0 - aktivuje anodu 0
        retlw   b'11111101'     ; cit_m=1 - aktivuje anodu 1
        retlw   b'11111011'     ; cit_m=2 - aktivuje anodu 2
        retlw   b'11110111'     ; cit_m=3 - aktivuje anodu 3
;***************************************************************************
; Rutina rozsvt na 5ms jednu slici ze ty monch. Vbr slice se
; provd jednak na zklad bitu hm registru stav1 a jednak na zklad
; hodnoty tae multiplexu cit_m.
zobraz  movlw   0ffh
        movwf   porta           ; odpojen anod displeje
        movlw   sec
        movwf   fsr             ; adresa registru sec do fsr
        btfss   hm              ; zobrazujeme hod a min? (bit=0?)
        incf    fsr, f          ; ano => v fsr je adresa min
                                ; ne  => nic se nedje
        bcf     carry           ; nulovn carry pro rotaci
        rrf     cit_m, w        ; ta multiplexu dlen dvma je ve w
                                ; v carry je 1, byl-li cit_m lich,
                                ;            0, byl-li cit_m sud
        iorlw   00h             ; nastavuje pznak zero stavovho slova (bit 2)
                                ; nutn - instrukce rrf to nedl
        btfss   zero            ; pvodn hodnota cit_m = 0 nebo 1? (Z=1?)
        incf    fsr, f          ; ne  => fsr ukazuje na nsledujc registr:
                                ;        min, jsme-li v reimu min, sec
                                ;        hod, jsme-li v reimu hod, min
                                ; ano => nic se nedje
        movf    indf, w         ; vybran registr do w
        movwf   digit           ; a w do digit
        btfsc   carry           ; cit_m byl lich? (C=1?)
        swapf   digit, f        ; ano => prohodme tveice
                                ; ne  => beze zmny
        movlw   b'00001111'
        andwf   digit, w        ; zamaskovn, vsledkem je jedna BCD slice
        call    tab1            ; pekdovn BCD slice na segmenty
        movwf   portb           ; kdy segment na port B
        bcf     carry           ; nulovn carry pro rotaci
        rrf     sec, w          ; vteiny dlen dvma do w
        btfsc   carry           ; zobrazuji sudou vteinu? (C=0?)
        goto    zobr_a          ; ne  => teka zhasnuta
                                ; ano => podle cit_m rozsvtme teku
        movf    cit_m, w
        xorlw   02h
        btfsc   zero            ; cit_m = 2? (Z=1?)
        bcf     dp              ; ano => rozsvtme teku
                                ; ne  => nic se nedje
zobr_a  movf    cit_m, w        ; cit_m do w
        call    tab2            ; podle cit_m dekdujeme jednu anodu
        movwf   porta           ; aktivace pslun anody
        incf    cit_m, f        ; inkrementujeme cit_m
        movlw   b'00000011'
        andwf   cit_m, f        ; zamaskovn, cit_m te t jen do 3
        retlw   00h             ; konec
;***************************************************************************
; Rutina zajist oeten zkmit pi ten tlatek a zrove zajist na-
; staven pslunch bit registru stav1, ktermi se d stav systmu.
; Rutina te tlatka kadch 20ms (vyuvn registr cit_m), a je-li tla-
; tko dreno alespo dvakrt za sebou, uzn se stisknut za platn.
tlacit  movf    cit_m, w
        btfss   zero            ; cit_m = 0? (Z=1?)
        retlw   00h             ; ne  => konec
        movlw   b'11111111'     ; ano => ten stavu tlatek
        movwf   porta           ; odpojen anod displeje
        movwf   portb           ; odpojen katod displeje
        bnk1                    ; banka 1
        movlw   b'11111111'
        movwf   trisb           ; port B jako vstupn
        bnk0                    ; zpt na banku 0
        movlw   .56
        movwf   cit_p           ; ta prodlevy = 56
tlac_a  decfsz  cit_p, f        ; prodleva na ustlen stavu na sbrnici
        goto    tlac_a          ; asi 200s
        movf    portb, w        ; ten portu B (stav tlatek)
                                ; tlatko stisknuto => na pinu je 0
        xorlw   b'11111111'     ; negace stavu tlatek
        andlw   b'00001111'     ; zamaskovn nepotebnch bit
                                ; tlatko stisknuto => bit registru je 1
        movwf   new             ; pepis stavu tlatek do registru new
        movlw   b'11111111'
        movwf   portb           ; odpojen katod displeje ped pepnutm smru
        bnk1                    ; banka 1
        movlw   b'00000000'
        movwf   trisb           ; port B opt jako vstup
        bnk0                    ; zpt na banku 0
        btfss   push            ; tlatko stle dreno? (bit push=1?)
        goto    tlac_b          ; ne  => dal zpracovn
                                ; ano => test, zda-li bylo putno
        clrf    old             ; nulovn old
        movf    new, w
        btfsc   zero            ; new = 0? (Z=1?)
        bcf     push            ; ano => tlatko putno, bit shozen, konec
        retlw   00h             ; ne  => pouze konec

tlac_b  movf    old, w          ; star stav tlatek do w
        andwf   new, w          ; ve w je new and old
        btfss   zero            ; new and old = 0? (Z=1?)
        goto    tlac_c          ; ne  => tlatko stisknuto
        movf    new, w          ; ano => pepis novho stavu do starho
        movwf   old
        retlw   00h             ; a konec

tlac_c  bsf     push            ; tlatko dreno, nastaven bitu
        btfss   new, 0          ; stisknuto tlatko start/stop? (bit0=1?)
        goto    tlac_d          ; ne  => dal testovn
        movlw   b'00000010'     ; ano => negace bitu stop, ostatn beze zmn
        xorwf   stav1, f
        btfsc   stop            ; hodiny stoj? (bit stop=1?)
        clrf    sec             ; ano => nulovn vtein a konec
        retlw   00h             ; ne  => pouze konec

tlac_d  btfss   new, 1          ; stisknuto tlatko pepnn? (bit1=1?)
        goto    tlac_e          ; ne  => dal testovn
        movlw   b'00000100'     ; ano => negace bitu hm, ostatn beze zmn
        xorwf   stav1, f
        retlw   00h             ; a konec

tlac_e  btfss   new, 2          ; stisknuto tlatko nastaven hod? (bit2=1?)
        goto    tlac_f          ; ne  => stisknuto tlatko nastaven min
        movlw   hod             ; ano => inkrementujeme hodiny
        movwf   fsr
        movlw   24h
        movwf   konec           ; vbr hodin
        call    aktual          ; aktualizace hodin
        retlw   00h             ; a konec

tlac_f  movlw   min             ; inkrementujeme minuty
        movwf   fsr
        movlw   60h
        movwf   konec           ; vbr minut
        call    aktual          ; aktualizace minut
        retlw   00h             ; a konec
;***************************************************************************
; Aktualizan rutina, vstup je adresa registru, jen se m aktualizovat
; (uloen ped volnm do fsr) a hodnota pro peteen (registr konec).
; Rutina pite jedniku s BCD korekc k registru, na kter ukazuje fsr.
; Jestlie se tento registr po piten jedniky rovn registru konec,
; rutina tento registr nuluje a nastavuje Z=1.
aktual  movlw   .7
        addwf   indf, f         ; pite do indf 1 s BCD korekc
        btfsc   dcarry
        goto    akt_a
        movlw   .6
        subwf   indf, f
akt_a   movf    konec, w
        xorwf   indf, w
        btfsc   zero            ; indf = konec? (Z=1?)
        clrf    indf            ; ano => nulovan indf
        retlw   00h             ; ne  => konec
;***************************************************************************
; Rutina zajist ekn 5ms (ne od okamiku voln rutiny, ale od poslednho
; peteen tmr0).
_5ms    comf    tmr0, w
        btfss   zero            ; tmr0 = 0ffh? (Z=1?)
        goto    _5ms            ; ne  => ekme
                                ; ano => testujeme peteen
_5ms_a  btfsc   tmr0, 0         ; tmr0 petekl? (bit0=0?)
        goto    _5ms_a          ; ne  => ekme na peteen
        retlw   00h             ; ano => konec
;***************************************************************************
; Inicializan rutina, nastav porty a stav systmu, vynuluje hodiny,
; minuty, vteiny a pejde do reimu relnho asu se zobrazovnm hodin
; a minut.
init    bnk0                    ; banka 0
        clrf    intcon          ; peruen zakzno
        movlw   0ffh
        movwf   porta           ; odpojen anod displeje
        movwf   portb           ; odpojen katod displeje
        bnk1                    ; banka 1
        movlw   00h
        movwf   trisa           ; port A jako vstupn
        movwf   trisb           ; port B jako vstupn
        movlw   b'10000011'     ; tmr0 buzen intern, peddli 1:16,
        movwf   roption         ; pull-up disable
        bnk0                    ; zpt na banku 0
        clrf    stav1           ; poten nastaven stavu systmu
        clrf    cit_m           ; nulovn tae multiplexu
        clrf    hod             ; nulovn hodin
        clrf    min             ; nulovn minut
        clrf    sec             ; nulovn vtein
        clrf    new             ; nulovn registru pro stav tlatek
        clrf    old             ; nulovn registru pro stav tlatek
        clrf    tmr0            ; nulovn tmr0
        goto    real            ; konec, skok do reimu relnho asu
;***************************************************************************
real    movlw   .200
        movwf   citac           ; hlavn ta na 1s
real_a  decfsz  citac, f        ; uplynula 1s?
        goto    real_b          ; ne  => jdeme dle
        movlw   .200
        movwf   citac           ; ano => znovunastaven tae
        btfsc   stop            ; hodiny b? (bit stop=0?)
        goto    real_b          ; ne  => jdeme dle
        movlw   sec             ; ano => aktualizujeme as
        movwf   fsr
        movlw   60h
        movwf   konec           ; vbr vtein
        call    aktual          ; aktualizace vtein
        btfss   zero            ; sec = 60? (Z=1?)
        goto    real_b          ; ne  => pokraujeme
        movlw   min             
        movwf   fsr             ; ano => vbr minut
        call    aktual          ; aktualizace minut
        btfss   zero            ; min = 60? (Z=1?)
        goto    real_b          ; ne  => pokraujeme
        movlw   hod
        movwf   fsr
        movlw   24h
        movwf   konec           ; ano => vbr hodin
        call    aktual          ; aktualizace hodin
real_b  call    tlacit          ; voln rutiny na zpracovn tlatek
        call    zobraz          ; zobrazen asu
        call    _5ms            ; ekej 5ms
        goto    real_a          ; a pod dokola
;***************************************************************************
        end
